unit WebModuleUnit1;

interface

uses
  System.SysUtils, System.Classes, System.Rtti, Web.HTTPApp,
  GraphQL.Schema, GraphQL.WebBroker, GraphQL.Comp.Schema,
  DataModule;

type
  TWebModule1 = class(TWebModule)
    GraphQLWebBrokerDispatcher1: TGraphQLWebBrokerDispatcher;
    procedure GraphQLSchema1InitSchema(Sender: TObject; Schema: TSchemaDocument);
  public
    { Public declarations }
  end;

var
  WebModuleClass: TComponentClass = TWebModule1;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

{ TWebModule1 }

procedure TWebModule1.GraphQLSchema1InitSchema(Sender: TObject; Schema: TSchemaDocument);
begin
  Schema.SetResolver('Query', 'hello', function(Args: TFieldResolverArgs): TValue
    begin
      Result := 'Hello, ' + Args.GetArgument('name').AsString;
    end
  );
end;

end.
